#!/usr/bin/python
import math, time, random, sys
         
'''
 Dieses Programm berechnet die Determinanten von n x n Matrizen (n=1, ....,100),
 die vorab mit Zufallszahlen zwischen 0 und 1 besetzt werden, durch
 Transformation der Matrix auf Dreiecksgestalt und Produktbildung der
 entstehenden Diagonalelemente. Die Rechenzeiten fuer die Berechnung der
 Determinanten werden mit ausgegeben.
 Will man Determinanten noch groesserer Matrizen berechnen, reicht es im
 untenstehenden Befehl
         for n in range(1,101):
 die Zahlen 1 und 101 zu aendern. Die 1 ist durch die erste
 Zahl zu ersetzen, die als kleinste Dimension einer Matrix gewaehlt werden
 soll, die Zahl anstelle von 101 muss um 1 groesser gewaehlt werden als die
 Zahl, die als groesste Dimension gewaehlt werden soll.
'''

def detcalc(a,n):
# Diese Funktion berechnet die Determinante der n x n Matrix a durch
# Transformation auf Dreiecksgestalt.
   if n >=3:
      det = 1.
      fact = 1.
      p = range(n)
      for k in range(0,n):
         if a[p[k]][k]==0:
            #Spalten-Pivot-Suche
            for i in range(k+1,n):
               if a[p[i]][k]!=0.:
                  #Pivot-Element gefunden; vertausche entsprechende Gleichungen
                  tmp = p[i]
                  p[i] = p[k]
                  p[k] = tmp
                  fact = - fact
                  break
               if i == n-1:
                  #kein Pivot-Element vorhanden --> det = 0.
                  det = 0.
                  return det
         for i in range(k+1,n):
            factor = -a[p[i]][k]/a[p[k]][k]
            for j in range(k,n):
               a[p[i]][j]=a[p[i]][j]+factor*a[p[k]][j]
         det = det *a[p[k]][k]
      det = det * fact
      return det
   elif n==2:
      if float(a[0][0])!=0.:
         factor = -a[1][0]/a[0][0]
         a[1][1]=a[1][1]+factor*a[0][1]
         det = a[0][0]*a[1][1]
      else:
         det = -a[1][0]*a[0][1]
      return det
   elif n==1:
      return a[0][0]
   else:
      print "negative entry for matrix dimension; program stops"
      return

#################
# HAUPTPROGRAMM #
#################

print
print
print " Dieses Programm berechnet die Determinanten von n x n Matrizen "
print " fuer n=1, ....,100 durch Transformation der Matrix auf "
print " Dreiecksgestalt und Produktbildung der entstehenden Diagonalelemente. "
print " Der Rechenaufwand waechst wie n**3. Die Rechenzeiten werden gemeinsam "
print " mit dem Wert der Determinanten ausgegeben."
print " Dabei werden die Matrizen mit Zufallszahlen zwischen 0 und 1 besetzt."
print
print

print "   n       time      det "
print " ------------------------"
for n in range(1,101):
   a=range(n)
   x=range(n)
   for i in range(n):
      a[i]=range(n)
      for j in range(n):
         a[i][j]=random.random()
   time1=time.time()
   determa=detcalc(a,n)
   time2=time.time()
   print "%4i  %10.3f  %12.6f" %(n, time2-time1, determa)
sys.stdin.readline()

