#!/usr/bin/python
import math, time, random, sys
         
def gauss(at,x,r,n):
# Diese Funktion berechnet die Loesung x des (n x n)-GLS ax=b 
# mit dem Gausschen Eliminationsverfahren (und Spalten-Pivot-Suche, wenn
# ein Diagonalelement = 0 wird)
   b = range(n)
   a = range(n)
   p = range(n)
   y = range(n)
   for i in range(n):
      b[i]=float(r[i])
      a[i]=range(n)
      for j in range(n):
         a[i][j]=float(at[i][j])
   if n >=2:
      #bringe Matrix in obere dreiecksgestalt:
      for k in range(0,n):
         if a[p[k]][k]==0:
            #Spalten-Pivot-Suche
            for i in range(k+1,n):
               if a[p[i]][k]!=0.:
                  #Pivot-Element gefunden; vertausche entsprechende Gleichungen
                  tmp = p[i]
                  p[i] = p[k]
                  p[k] = tmp
                  break
               if i == n-1:
                  #kein Pivot-Element gefunden; Matrix ist singulaer
                  return "singulaer"
         for i in range(k+1,n):
            print a
            factor = -a[p[i]][k]/a[p[k]][k]
            b[p[i]]=b[p[i]]+factor*b[p[k]]
            for j in range(k,n):
               a[p[i]][j]=a[p[i]][j]+factor*a[p[k]][j]
      #rueckwaertseinsetzen
      if a[n-1][n-1]==0.:
         return "singulaer"
      else:
         for i in range(n-1,-1,-1):
            y[p[i]]=b[p[i]]
            for j in range(i+1,n):
               y[p[i]]=y[p[i]]-a[p[i]][j]*y[p[j]]
            y[p[i]]=y[p[i]]/a[p[i]][i]
            x[i]=y[p[i]]
         return "regulaer"
   elif n==1:
      if a[0][0]==0.:
         return "singulaer"
      else:
         x[0]=b[0]/a[0][0]
         return "regulaer" 
   else:
      print "negative entry for matrix dimension; program stops"
      return

#################
# HAUPTPROGRAMM #
#################

print
print "Dies ist ein Programm, das mit dem Gauss'schen Eliminationsverfahren"
print "lineare Gleichungsysteme bestehend aus n Gleichungen mit n Unbekannten"
print "loest. "
print
n = input("Anzahl der Gleichungen eingeben: ")
print 'Anzahl der Gleichungen: ', n
print
# Anlegen der n-dimensionalen Vektoren x und b und der (n x n) - Matrix a
a=range(n)
b=range(n)
x=range(n)
# Eingabe von a und b
print 'gib die Matrix-Koeffizienten der einzelnen Gleichungen durch Kommata getrennt ein; '
print 'Beispiel: 11.3, 2.7, 3, 4.7'
for i in range(1,n+1):
   txt= 'Koeffizienten der '+str(i)+'-ten Gleichung: '
   if n==1:
      a[0]=range(n)
      a[0][0]=float(input(txt))
   else:
      a[i-1]=input(txt)
print 'gib alle Werte der rechten Seite des linearen Gleichungssystems durch Kommate getrennt ein; '
print 'Beispiel: 37.4, 39.8, 501, 701.1' 
if n==1:
   b[0]=float(input('rechte Seite des Gleichungssystems: '))
else:
   b=input('rechte Seite des Gleichungssystems: ')

back = gauss(a,x,b,n)

# Ausgabe der Loesung
if back == "regulaer":
   print 'Die berechnete Loesung lautet x = ', x
elif back == "singulaer":
   print "Das Gleichungssystem ist nicht eindeutig loesbar."
   print "Programm endet."
sys.stdin.readline()
