#!/usr/bin/python
import math, time, random, sys
         
'''
 Dieses Programm berechnet die Loesung von Gleichungssystemen bestehend aus n 
 Gleichungen mit n Unbekannten. Die Koeffizienten des Gleichungssystems werden
 vorab mit Zufallszahlen zwischen 0 und 1 besetzt. Die rechte Seite b des GLS
 wird so gesetzt, dass alle Unbekannten als 1 herauskommen.
 Ausgegeben wird die benoetigte Rechenzeit zur Loesung des Gleichungssystems.
 Die Initialisierung der Matrix a und der rechten Seite b wird hierbei nicht
 mit gemessen.
 Aktuell werden Gleichungssysteme mit 50, 100, 150, ...., 400 Unbekannten
 geloest. Will man andere Werte fuer n einsetzen, so ist lediglich die
 for-Schleife in der zweiten Zeile des Programms zu modifizieren.
 Will man z.B. nur ein GLS mit 500 Unbekannten betrachten, so
 kann man diese Zeile aendern in
 for n in range(500,501):
'''

def gauss(a,x,b,n):
# Diese Funktion berechnet die Loesung x des (n x n)-GLS ax=b 
# mit dem gausschen eliminationsverfahren
   if n >=2:
      #bringe Matrix in obere dreiecksgestalt:
      for k in range(0,n):
         for i in range(k+1,n):
            factor = -a[i][k]/a[k][k]
            b[i]=b[i]+factor*b[k]
            for j in range(k,n):
               a[i][j]=a[i][j]+factor*a[k][j]
      #rueckwaertseinsetzen
      for i in range(n-1,-1,-1):
         x[i]=b[i]
         for j in range(i+1,n):
            x[i]=x[i]-a[i][j]*x[j]
         x[i]=x[i]/a[i][i]
      return 
   elif n==1:
      x[0]=b[0]/a[0][0]
      return 
   else:
      print "negative entry for matrix dimension; program stops"
      return


#################
# HAUPTPROGRAMM #
#################

print
print
print " Dieses Programm berechnet die Loesung von Gleichungssystemen bestehend aus n "
print " Gleichungen mit n Unbekannten. Die Koeffizienten des Gleichungssystems werden"
print " vorab mit Zufallszahlen zwischen 0 und 1 besetzt. Die rechte Seite b des GLS"
print " wird so gesetzt, dass alle Unbekannten als 1 herauskommen." 
print " Ausgegeben wird die benoetigte Rechenzeit zur Loesung des Gleichungssystems."
print " Die Initialisierung der Matrix a und der rechten Seite b wird hierbei nicht"
print " mit gemessen."
print " Aktuell werden Gleichungssysteme mit 50, 100, 150, ...., 400 Unbekannten"
print " betrachtet."

print
print
print "   n        time "
print " ----------------"
for n in range(50,401,50):
   a=range(n)
   b=range(n)
   x=range(n)
   for i in range(n):
      a[i]=range(n)
      b[i]=0.
      for j in range(n):
         a[i][j]=random.random()
         b[i]=b[i]+a[i][j]
   time1=time.time()
   gauss(a,x,b,n)
   time2=time.time()
   #print "n = ",n,", det = ",determa,", time = ",time2-time1
   print "%4i    %8.3f" %(n,  time2-time1)
sys.stdin.readline()

